(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@babel/runtime/regenerator'), require('@babel/runtime/helpers/asyncToGenerator'), require('@babel/runtime/helpers/classCallCheck'), require('@babel/runtime/helpers/createClass'), require('ptokens-utils'), require('ptokens-node'), require('ptokens-providers')) :
  typeof define === 'function' && define.amd ? define(['exports', '@babel/runtime/regenerator', '@babel/runtime/helpers/asyncToGenerator', '@babel/runtime/helpers/classCallCheck', '@babel/runtime/helpers/createClass', 'ptokens-utils', 'ptokens-node', 'ptokens-providers'], factory) :
  (global = global || self, factory(global.NodeSelector = {}, global._regeneratorRuntime, global._asyncToGenerator, global._classCallCheck, global._createClass, global['ptokens-utils'], global['ptokens-node'], global['ptokens-providers']));
}(this, (function (exports, _regeneratorRuntime, _asyncToGenerator, _classCallCheck, _createClass, ptokensUtils, ptokensNode, ptokensProviders) { 'use strict';

  _regeneratorRuntime = _regeneratorRuntime && Object.prototype.hasOwnProperty.call(_regeneratorRuntime, 'default') ? _regeneratorRuntime['default'] : _regeneratorRuntime;
  _asyncToGenerator = _asyncToGenerator && Object.prototype.hasOwnProperty.call(_asyncToGenerator, 'default') ? _asyncToGenerator['default'] : _asyncToGenerator;
  _classCallCheck = _classCallCheck && Object.prototype.hasOwnProperty.call(_classCallCheck, 'default') ? _classCallCheck['default'] : _classCallCheck;
  _createClass = _createClass && Object.prototype.hasOwnProperty.call(_createClass, 'default') ? _createClass['default'] : _createClass;

  var BOOT_TESTNET_ENDPOINT = 'https://testnet--bootnode-eu-1.p.network';
  var BOOT_MAINNET_ENDPOINT = 'https://mainnet--bootnode-eu-1.p.network';
  var getBootNodeEndpoint = function getBootNodeEndpoint(_network) {
    return _network === ptokensUtils.constants.networks.Mainnet ? BOOT_MAINNET_ENDPOINT : BOOT_TESTNET_ENDPOINT;
  };

  var NodeSelector = function () {
    function NodeSelector(_configs) {
      _classCallCheck(this, NodeSelector);
      var pToken = _configs.pToken,
          defaultNode = _configs.defaultNode;
      if (!ptokensUtils.helpers.isValidPTokenName(pToken)) throw new Error('Invalid pToken name');
      this.pToken = pToken.toLowerCase() === ptokensUtils.constants.pTokens.pETH ? ptokensUtils.constants.pTokens.pWETH : pToken.toLowerCase();
      var _helpers$parseParams = ptokensUtils.helpers.parseParams(_configs, _configs.nativeBlockchain ? ptokensUtils.helpers.getBlockchainType[_configs.nativeBlockchain] : ptokensUtils.helpers.getNativeBlockchainFromPtokenName(this.pToken)),
          hostBlockchain = _helpers$parseParams.hostBlockchain,
          hostNetwork = _helpers$parseParams.hostNetwork,
          nativeBlockchain = _helpers$parseParams.nativeBlockchain,
          nativeNetwork = _helpers$parseParams.nativeNetwork;
      this.hostBlockchain = hostBlockchain;
      this.hostNetwork = hostNetwork;
      this.nativeBlockchain = nativeBlockchain;
      this.nativeNetwork = nativeNetwork;
      this.selectedNode = defaultNode || null;
      this.nodes = [];
      this.provider = new ptokensProviders.HttpProvider();
    }
    _createClass(NodeSelector, [{
      key: "checkConnection",
      value: function () {
        var _checkConnection = _asyncToGenerator( _regeneratorRuntime.mark(function _callee(_endpoint, _timeout) {
          var _yield$this$provider$, host_blockchain, host_network, native_blockchain, native_network;
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  this.provider.setEndpoint(_endpoint);
                  _context.next = 4;
                  return this.provider.call('GET',
                  "/".concat(this.pToken, "-on-").concat(ptokensUtils.helpers.getBlockchainShortType(this.hostBlockchain), "/get-info"), null, _timeout);
                case 4:
                  _yield$this$provider$ = _context.sent;
                  host_blockchain = _yield$this$provider$.host_blockchain;
                  host_network = _yield$this$provider$.host_network;
                  native_blockchain = _yield$this$provider$.native_blockchain;
                  native_network = _yield$this$provider$.native_network;
                  return _context.abrupt("return", Boolean(host_blockchain === this.hostBlockchain && host_network === this.hostNetwork && native_blockchain === this.nativeBlockchain && native_network === this.nativeNetwork));
                case 12:
                  _context.prev = 12;
                  _context.t0 = _context["catch"](0);
                  throw new Error("Error during checking node connection: ".concat(_context.t0.message));
                case 15:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this, [[0, 12]]);
        }));
        function checkConnection(_x, _x2) {
          return _checkConnection.apply(this, arguments);
        }
        return checkConnection;
      }()
    }, {
      key: "getApi",
      value: function () {
        var _getApi = _asyncToGenerator( _regeneratorRuntime.mark(function _callee2() {
          var node;
          return _regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.prev = 0;
                  if (this.selectedNode) {
                    _context2.next = 7;
                    break;
                  }
                  _context2.next = 4;
                  return this.select();
                case 4:
                  node = _context2.sent;
                  if (node) {
                    _context2.next = 7;
                    break;
                  }
                  throw new Error('No Nodes Available');
                case 7:
                  return _context2.abrupt("return", this.selectedNode.api);
                case 10:
                  _context2.prev = 10;
                  _context2.t0 = _context2["catch"](0);
                  throw new Error("Error during getting node api: ".concat(_context2.t0.message));
                case 13:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this, [[0, 10]]);
        }));
        function getApi() {
          return _getApi.apply(this, arguments);
        }
        return getApi;
      }()
    }, {
      key: "select",
      value: function () {
        var _select = _asyncToGenerator( _regeneratorRuntime.mark(function _callee3() {
          var feature, filteredNodesByFeature, nodesNotReachable, index, selectedNode;
          return _regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _context3.prev = 0;
                  this.provider.setEndpoint(getBootNodeEndpoint(ptokensUtils.helpers.getNetworkType(this.hostNetwork)));
                  _context3.next = 4;
                  return this.provider.call('GET', '/peers');
                case 4:
                  this.nodes = _context3.sent.peers;
                  feature = "".concat(this.pToken, "-on-").concat(ptokensUtils.helpers.getBlockchainShortType(this.hostBlockchain));
                  filteredNodesByFeature = this.nodes.filter(function (node) {
                    return node.features.includes(feature);
                  });
                  if (!(filteredNodesByFeature.length === 0)) {
                    _context3.next = 9;
                    break;
                  }
                  throw new Error('No nodes available relating to the selected pToken');
                case 9:
                  nodesNotReachable = [];
                case 10:
                  index = Math.floor(Math.random() * filteredNodesByFeature.length);
                  selectedNode = filteredNodesByFeature[index];
                  _context3.next = 14;
                  return this.checkConnection(selectedNode.webapi);
                case 14:
                  _context3.t0 = _context3.sent;
                  if (!_context3.t0) {
                    _context3.next = 17;
                    break;
                  }
                  _context3.t0 = !nodesNotReachable.includes(selectedNode);
                case 17:
                  if (!_context3.t0) {
                    _context3.next = 21;
                    break;
                  }
                  return _context3.abrupt("return", this.setSelectedNode(selectedNode.webapi));
                case 21:
                  if (!nodesNotReachable.includes(selectedNode)) nodesNotReachable.push(selectedNode);
                case 22:
                  if (!(nodesNotReachable.length === filteredNodesByFeature.length)) {
                    _context3.next = 24;
                    break;
                  }
                  throw new Error('All nodes relating to the selected pToken appear to be unavailable');
                case 24:
                  _context3.next = 10;
                  break;
                case 26:
                  _context3.next = 31;
                  break;
                case 28:
                  _context3.prev = 28;
                  _context3.t1 = _context3["catch"](0);
                  throw new Error(_context3.t1.message);
                case 31:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, this, [[0, 28]]);
        }));
        function select() {
          return _select.apply(this, arguments);
        }
        return select;
      }()
    }, {
      key: "setSelectedNode",
      value: function setSelectedNode(_node) {
        if (_node instanceof ptokensNode.Node) {
          this.selectedNode = _node;
          return this.selectedNode;
        }
        this.selectedNode = new ptokensNode.Node({
          pToken: this.pToken,
          blockchain: this.hostBlockchain,
          provider: new ptokensProviders.HttpProvider(_node)
        });
        return this.selectedNode;
      }
    }]);
    return NodeSelector;
  }();

  exports.NodeSelector = NodeSelector;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
